class ApplicationController < ActionController::Base
  protect_from_forgery
  layout 'application'

  FIRST_PHOTO = DateTime.parse('2010-06-05')

  def render_404(exception = nil)
		if exception
		  logger.info "Rendering 404 with exception: #{exception.message}"
		end

		respond_to do |format|
		  format.html { render :file => "#{Rails.root}/public/404.html", :status => :not_found, :layout => false }
		  format.xml  { head :not_found }
		  format.any  { head :not_found }
		end
	end

	def after_sign_in_path_for(resource)
		if params[:redirect_to] and params[:redirect_to].start_with? "http"
			params[:redirect_to]
		else
			super
		end
  end

	def after_sign_out_path_for(resource)
		if params[:redirect_to] and params[:redirect_to].start_with? "http"
			params[:redirect_to]
		else
			super
		end
  end


end
