module PhotoStyleHelper
	
	def get_form_fields(style)
		html = StringIO.new
	
		style.instance_variables.each do |var|
			html << '<fieldset>'
			html << '<legend>' << style.instance_variable_get(var).selector << '</legend>'
			html << get_css_fields(style.instance_variable_get(var).selector, style.instance_variable_get(var).style)
			html << '</fieldset>'
		end
		
		# add requited javascript
		content_for :additional_javascript do
			javascript_include_tag 'colorpicker.js', 'jquery.ImageColorPicker.min.js', 'photos_form.js'
		end
		
		# add required css
		content_for :head do
			stylesheet_link_tag 'colorpicker.css', 'ImageColorPicker.css'
		end
		
		html.string.html_safe
	end
	
	private
	
	def get_css_fields(selector, style)
		html = StringIO.new
	
		style.each do |css_property, value| 
			html << css_property << ': '

			case css_property
			when 'color', 'background-color'
				html << get_color_picker(selector, css_property, value)
			when 'border', 'box-shadow'
				html << text_field_tag(get_field_name(selector, css_property), value)
			else 
				''
			end
			
			html << '<br />'
		end
		
		html.string
	end
	
	def get_color_picker(selector, css_property, value)
		html = StringIO.new
    html << '<div>'
		html << '<div class="colorSelector">'
		html << '<div class="colorpicker-color" style="background-color: ' << value << ';"></div>'
		html << hidden_field_tag(get_field_name(selector, css_property), value)
		html << '</div>'
		html << '<div class="setSelectedColor">Set Selected Color: <span class="selectedColorHex"></span></div>'
		html << '</div>'
		html.string
	end
	
	def get_field_name(selector, css_property)
		'css_' + selector + '_' + css_property
	end
end
