module PhotosHelper

	def get_image_as_html(photo, options={})
	
		image = %(<img src="#{photo.url(:thumb)}"/>)
		html = StringIO.new
			
		if options[:add_link] == true
			image = %(<a href="#{photo_url(photo)}">#{image}</a>)
		end
		
		html << image
		
		if options[:add_text] == true
			text = %(<p>#{ textile photo.text }</p>)
		end
		
		html << text
		
		html.string.html_safe
	end
	
	def get_image_title(photo)
		html = StringIO.new
		html <<	photo.date.strftime('%Y-%m-%d')
		html << " // #{photo.title}" unless photo.title.blank?
		
		html.string.html_safe
	end
	
end
