var TheImage = {
  init: function(options, elem) {
    this.options = $.extend({},this.options,options);
    this.elem  = elem;
    this.$elem = $(elem);
    this._build();
		return this;
  },

  options: {
		ajaxLoaderId: '#ajax-loader',
		extraInfoId: '#extrainfo',
		wrapperId: '#image-wrapper',
		descriptionId: '#description'
  },

	events: {
		hideAjaxLoader: function(e){
			var that = e.data.that;
			$(that.options.descriptionId).show();
			$(that.options.ajaxLoaderId).hide();
		},

		showAjaxLoader: function(e){
			var that = e.data.that;
			$(that.options.ajaxLoaderId).show();
		},

		resize: function(e) {
			var that = e.data.that;
			that.resize(e.data.type);
		},

		showExtraInfo: function(e) {
			var that = e.data.that;
			that.$extraInfo.stop(true, true).slideDown();
			that._positionExtraInfo(that.$extraInfo, that.$elem);
		},

		hideExtraInfo: function(e) {
			var that = e.data.that;
			that.$extraInfo.stop(true, true).slideUp();
		}

	},

	getBackgroundColorBrightness: function() {
		var backgroundColor = $('body').css("background-color");
		return this._getBrightness(backgroundColor);
	},

	resize: function(type) {
		var maxDimension;
		var widthMargin     = 150;
		var heightMargin 		= 110;
		var borderMargin		= (this.$elem.outerHeight()-this.$elem.height());
		var that = this;
		var windowH      = $(window).height() - heightMargin;
		var windowW      = $(window).width() - widthMargin;
		var theImage     = new Image();
		theImage.src     = this.$elem.attr("src");
		var imgwidth     = theImage.width;
		var imgheight    = theImage.height;

		maxDimension = imgwidth > imgheight ? imgwidth : imgheight;

		if ((imgwidth > windowW) || (imgheight > windowH)) {
			if (imgwidth > imgheight) {
				var newwidth = windowW;
				var ratio = imgwidth / windowW;
				var newheight = imgheight / ratio;
				theImage.height = newheight;
				theImage.width = newwidth;
				if (newheight > windowH) {
			    var newnewheight = windowH;
			    var newratio = newheight / windowH;
			    var newnewwidth = newwidth / newratio;
			    theImage.width = newnewwidth;
			    theImage.height = newnewheight;
				}
			} else {
				var newheight = windowH;
				var ratio = imgheight / windowH;
				var newwidth = imgwidth / ratio;
				theImage.height = newheight;
				theImage.width= newwidth;
				if (newwidth > windowW) {
			    var newnewwidth = windowW;
			    var newratio = newwidth / windowW;
			    var newnewheight = newheight / newratio;
			    theImage.height = newnewheight;
			    theImage.width= newnewwidth;
				}
			}
		}

		that._setHeights();

		if ((type == 1) && (!$.browser.msie)) {
			this.$elem.stop(true).animate({
				'width':theImage.width+'px',
				'height':theImage.height+'px'
			}, 1000, function(){
				that.$wrapper.width(theImage.width + 'px');
				that._positionExtraInfo(that.$extraInfo, that.$elem);
			});
		} else {
			this.$elem.css({
				'width':theImage.width+'px',
				'height':theImage.height+'px'
			});
			this.$wrapper.width(theImage.width + 'px');
			this._positionExtraInfo(this.$extraInfo, this.$elem);
		}



	},

	_h2d: function(h) {
		return parseInt(h,16);
	},

	_getBrightness: function(color) {
		var red, green, blue, rgbvals;

		// browser return color information in different
		// ways. Can be "#ffffff", "rgb(255, 255, 255)", "rgba(255, 255, 255, 1)"
		if (color.substring(0, 1) === '#') {
			red = this._h2d(color.substring(0,2));
			green = this._h2d(color.substring(2, 2));
			blue = this._h2d(color.substring(4, 2));
		} else if (color.substring(0, 4) === 'rgba') {
			rgbvals = /rgba\((.+),(.+),(.+)\)/i.exec(color);
			red = rgbvals[1].trim();
			green = rgbvals[2].trim();
			blue = rgbvals[3].trim();
		} else if (color.substring(0, 3) === 'rgb') {
			rgbvals = /rgb\((.+),(.+),(.+)\)/i.exec(color);
			red = rgbvals[1].trim();
			green = rgbvals[2].trim();
			blue = rgbvals[3].trim();
		} else {
			return 0;
		}

		return Math.sqrt(
			red * red * 0.241 +
      green * green * 0.691 +
      blue * blue * 0.068);
	},

	_positionExtraInfo: function($extraInfo, $elem) {
		$extraInfo.show();
	  $extraInfo.offset($elem.offset());
	  $extraInfo.css('width', $elem.width());
	  $extraInfo.hide();
	},

	_setHeights: function() {
		$("#facebook-comments").height( $(window).height() );
		$("#facebook-comments").css("position", "absolute").css("top", $(window).height() + "px");
		$("#wrapper").height( $(window).height() );
	},

  _build: function(){
	  this.$extraInfo = $(this.options.extraInfoId);
	  this.$wrapper = $(this.options.wrapperId);
		$(this.options.descriptionId).css("backgroundColor", $("body").css("backgroundColor"))
		$(this.options.descriptionId).hide();

		this._setHeights();

    // no need to build any additional HTML. Happy just with the image :-)
    if (this.$elem[0].complete) {
		  this.resize(0);
			$(this.options.ajaxLoaderId).hide();
			$(this.options.descriptionId).show();
		}

		// attach events
		this.$elem.bind('load', { that: this }, this.events.hideAjaxLoader);
		this.$elem.bind('load', { that: this, type: 0 }, this.events.resize);
		$(window).bind('resize', { that: this, type: 1 }, this.events.resize);

		this.$wrapper.unbind();

		this.$wrapper.bind('mouseenter', { that: this }, this.events.showExtraInfo);
		this.$wrapper.bind('mouseleave', { that: this }, this.events.hideExtraInfo);

		$("#yesterday").bind('mouseenter', function(e){
			$("#yesterday-text").show();
		});
		$("#yesterday").bind('mouseleave', function(e){
			$("#yesterday-text").hide();
		});
		$("#tomorrow").bind('mouseenter', function(e){
			$("#tomorrow-text").show();
		});
		$("#tomorrow").bind('mouseleave', function(e){
			$("#tomorrow-text").hide();
		});

		$("#comment").bind('click', function(){
			$.scrollTo($("#facebook-comments"), {duration:1500});
		});

		// global:
		$(document).bind('keyup', 'right', function(){
			var loc = $("#tomorrow").find("a").attr("href");
			if ( loc != undefined ) {
				window.location = loc;
			}
		});
		$(document).bind('keyup', 'left', function(){
			var loc = $("#yesterday").find("a").attr("href");
			if ( loc != undefined ) {
				window.location = loc;
			}
		});
  }
};

$.plugin("pyTheImage", TheImage);
